package br.ufpr.tads.jfinisher;

import java.util.Arrays;

public class Sequence {

    private byte[] seq = {};

    public Sequence() {
    }

    public Sequence(int size) {
        this.seq = new byte[size];
    }

    public Sequence(String s) {
        this.setSeq(s);
    }

    public Sequence(byte[] s) {
        this.setSeq(s);
    }

    public Sequence(char[] s) {
        this.setSeq(s);
    }

    public String getSeqStr() {
        return new String(this.getSeq());
    }
    
    public byte[] getSeq() {
        return seq;
    }

    public String getSeqStr(int start, int end) {
        byte[] sub = Arrays.copyOfRange(this.getSeq(), start, end + 1);
        return new String(sub);
    }

    public byte[] getSeq(int start, int end) {
        byte[] sub = Arrays.copyOfRange(this.getSeq(), start, end + 1);
        return sub;
    }
    
    public void setSeq(byte[] s, int st, int en) {
        System.arraycopy(s, 0, this.seq, st, en - st + 1);
    }

    public void setSeqFill(byte b) {
        this.setSeqFill(0, this.getLength() - 1, b);
    }

    public void setSeqFill(int st, int en, byte b) {
        //+1 pois funo fill nao preenche ultimo elemnto
        Arrays.fill(this.seq, st, en + 1, b);
    }

    public void setSeq(String s) {
        this.seq = s.getBytes();
    }

    public void setSeq(byte[] s) {
        this.seq = s;
    }

    public void setSeq(char[] s) {
        String str = new String(s);
        this.seq = str.getBytes();
    }

    public int getLength() {
        try{
            return this.getSeq().length;
        }catch(NullPointerException ex){
            return 0;
        } 
    }
    
    public void appendSeq(Sequence seq){
        byte[] one = this.seq;
        byte[] two = seq.getSeq();
        byte[] combined = new byte[one.length + two.length];

        System.arraycopy(one,0,combined,0         ,one.length);
        System.arraycopy(two,0,combined,one.length,two.length);
        
        this.setSeq(combined);
    }
}