package br.ufpr.tads.jfinisher.action;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.Sequence;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

public class GroupCharactersAction implements ActionListener {

    private OpenSequence openSequence;
    private String character;

    public GroupCharactersAction(OpenSequence os, String c) {
        openSequence = os;
        character = c;
    }

    @Override
    public void actionPerformed(ActionEvent e) {

        int confirm = JOptionPane.showConfirmDialog(null, JFinisher.textResource.getString("GroupCharactersAction.confirm.text"),"", JOptionPane.OK_CANCEL_OPTION);
        if (confirm == JOptionPane.OK_OPTION) {


            int posI, posF;
            if (openSequence.getOpenSequenceAlignmentSelected() == null) {
                posI = 0;
                posF = openSequence.getSequence().getLength() - 1;
            } else {
                posI = openSequence.getOpenSequenceAlignmentSelected().getPosition();
                posF = openSequence.getOpenSequenceAlignmentSelected().getPosition() + openSequence.getSequence().getLength() - 1;
            }

            boolean addChar = false;
            StringBuilder newSequence = new StringBuilder();

            for (int i = 0; i <= openSequence.getSequence().getLength() - 1; i++) {
                String c = openSequence.getSequence().getSeqStr(i, i);
                if (character.equalsIgnoreCase(c)) {
                    if (!addChar) {
                        newSequence.append(c);
                        addChar = true;
                    }
                } else {
                    newSequence.append(c);
                    addChar = false;
                }
            }
            Sequence s = new Sequence(newSequence.toString());
            openSequence.rewriteSequence(s);

            //Atualiza tela
            JFinisher.mainFrame.sspContigs.refreshSequence(openSequence);

            //Atualiza consenso
            JFinisher.mainFrame.sspReference.refreshConsensusSequence(posI, posF);

            //Atualiza mapa
            JFinisher.mainFrame.sspMap.refreshSequence(openSequence);

            openSequence.getSequencePanel().clearHighlight();
            JFinisher.mainFrame.sspReference.refreshViewportView();
            JFinisher.mainFrame.sspContigs.refreshViewportView();

        }
    }
}