/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.ufpr.tads.jfinisher.action;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.util.WindowUtil;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author vitor
 */
public class OpenContigsAction extends OpenAction {

    private FileNameExtensionFilter fe = null;

    public OpenContigsAction() {
        fe = new FileNameExtensionFilter(JFinisher.textResource.getString("OpenContigsAction.files"), "fas", "fa", "fasta", "fna", "ffn", "faa");
        this.setEnabled(true);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        
        Thread t = new Thread() {

            @Override
            public void run() {
                JFileChooser openDialog = openDialog(true);
                if (openDialog.showOpenDialog(JFinisher.mainFrame) == JFileChooser.APPROVE_OPTION) {
                    boolean fileAlreadyExist=false;
                    for (File openFile : openDialog.getSelectedFiles()) {
                        //Verifica se arquivo j foi aberto
                        for (OpenSequence auxOs : JFinisher.getOpenSequences()) {
                            if(auxOs.getFile().equals(openFile.getAbsolutePath())){
                                fileAlreadyExist=true;
                                break;
                            }
                        }
                        if(fileAlreadyExist){
                            JOptionPane.showMessageDialog(JFinisher.mainFrame, JFinisher.textResource.getString("OpenContigsAction.fileAlreadyAdded"), JFinisher.textResource.getString("Title.warning"), JOptionPane.WARNING_MESSAGE);
                        }else{
                            try {
                                ArrayList<OpenSequence> oss = openFile(openFile);
                                addSequence(oss);
                            } catch (IOException ex) {
                                JOptionPane.showMessageDialog(JFinisher.mainFrame, JFinisher.textResource.getString("Error.openFile"), JFinisher.textResource.getString("Error.title"), JOptionPane.ERROR_MESSAGE);
                            }
                        }
                    }
                    JFinisher.mainFrame.posOpenContig();
                }
                openDialog.removeChoosableFileFilter(fe);
            }
        };
        t.start();
    }

    public JFileChooser openDialog(boolean multiSelectionEnabled) {
        JFileChooser openDialog = WindowUtil.getOpenChooser();
        openDialog.setMultiSelectionEnabled(multiSelectionEnabled);
        openDialog.setDialogTitle(JFinisher.textResource.getString("OpenContigsAction.title"));
        openDialog.setDialogType(JFileChooser.OPEN_DIALOG);
        openDialog.setFileFilter(fe);
        return openDialog;
    }
}
