/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.ufpr.tads.jfinisher.action;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.util.WindowUtil;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.ArrayList;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author vitor
 */
public class OpenReferenceAction extends OpenAction {

    private FileNameExtensionFilter fe = null;

    public OpenReferenceAction() {
        fe = new FileNameExtensionFilter(JFinisher.textResource.getString("OpenReferenceAction.files"), "gbk", "fas", "fa", "fasta", "fna");
        this.setEnabled(true);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Thread t = new Thread() {

            @Override
            public void run() {
                JFileChooser openDialog = openDialog();
                if (openDialog.showOpenDialog(JFinisher.mainFrame) == JFileChooser.APPROVE_OPTION) {
                    try {
                        ArrayList<OpenSequence> oss = openFile(openDialog.getSelectedFile());
                        addSequence(oss);
                        JFinisher.mainFrame.posOpenReference();
                    } catch (IOException ex) {
                        JOptionPane.showMessageDialog(JFinisher.mainFrame, JFinisher.textResource.getString("Error.openFile"), JFinisher.textResource.getString("Error.title"), JOptionPane.ERROR_MESSAGE);
                    }
                    openDialog.removeChoosableFileFilter(fe);
                }
                
            }
        };
        t.start();
    }

    public JFileChooser openDialog() {
        JFileChooser openDialog = WindowUtil.getOpenChooser();
        openDialog.setDialogTitle(JFinisher.textResource.getString("OpenReferenceAction.title"));
        openDialog.setDialogType(JFileChooser.OPEN_DIALOG);
        openDialog.setFileFilter(fe);
        return openDialog;
    }
}
