/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.ufpr.tads.jfinisher.action;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.frame.MainFrame;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.OpenSequenceAlignment;
import br.ufpr.tads.jfinisher.util.WindowUtil;
import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.StaxDriver;
import java.awt.event.ActionEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author vitor
 */
public class SaveProjectAction extends AbstractAction implements Action {

    private FileNameExtensionFilter fe = null;
    private boolean setFile;

    public SaveProjectAction(boolean sf) {
        fe = new FileNameExtensionFilter(JFinisher.textResource.getString("SaveProjectAction.files"), "xml");
        this.setFile = sf;
    }

    @Override
    public void actionPerformed(ActionEvent e) {

        XStream xstream = new XStream(new StaxDriver());
        xstream.omitField(OpenSequence.class, "sequence");
        xstream.omitField(OpenSequence.class, "sequencePanel");
        xstream.omitField(OpenSequence.class, "mapLabel");
        xstream.omitField(OpenSequenceAlignment.class, "mapLabel");
        xstream.omitField(OpenSequence.class, "aligner");
        xstream.omitField(OpenSequence.class, "selectedSeq");
        xstream.omitField(OpenSequence.class, "entry");

        //xstream.alias("data", List.class);
        //xstream.alias("sequence", OpenSequence.class);
        final String xml = xstream.toXML(JFinisher.getOpenSequences());

        //Caso ja esteja trabalhando em um projeto, salva em cima
        if (JFinisher.getOpenProject() != null && setFile==false) {
            writeFile(new File(JFinisher.getOpenProject()), xml);
        } else {
            Thread t = new Thread() {
                @Override
                public void run() {
                    boolean doWrite = false;
                    JFileChooser openDialog = WindowUtil.getOpenChooser();
                    openDialog.setDialogTitle(JFinisher.textResource.getString("SaveProjectAction.title"));
                    openDialog.setDialogType(JFileChooser.SAVE_DIALOG);
                    openDialog.setFileFilter(fe);
                    openDialog.setCurrentDirectory(new File("."));
                    openDialog.setSelectedFile(new File("*.xml"));
                    if (openDialog.showSaveDialog(JFinisher.mainFrame) == JFileChooser.APPROVE_OPTION) {
                        if (openDialog.getSelectedFile().exists()) {
                            int overwrite = JOptionPane.showConfirmDialog(JFinisher.mainFrame, JFinisher.textResource.getString("SaveProjectAction.fileExists"), JFinisher.textResource.getString("SaveProjectAction.title") + " [" + openDialog.getSelectedFile().getName() + "]", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
                            if (overwrite == JOptionPane.YES_OPTION) {
                                doWrite = true;
                            }
                        }else{
                            doWrite = true;
                        }
                    }
                    if(doWrite){
                        writeFile(openDialog.getSelectedFile(), xml);
                        JFinisher.setOpenProject(openDialog.getSelectedFile().getAbsolutePath());
                    }
                    openDialog.removeChoosableFileFilter(fe);
                }
            };
            t.start();
        }
    }

    private void writeFile(File file, String content) {
        try {
            Writer output = null;
            output = new BufferedWriter(new FileWriter(file));
            output.write(content);
            output.close();
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(JFinisher.mainFrame, JFinisher.textResource.getString("Error.unknown"), JFinisher.textResource.getString("Error.title"), JOptionPane.ERROR_MESSAGE);
            Logger.getLogger(SaveProjectAction.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
