/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * OptionsFrame.java
 *
 * Created on 10/10/2011, 20:09:06
 */
package br.ufpr.tads.jfinisher.frame;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.OpenSequenceAlignment;
import br.ufpr.tads.jfinisher.Sequence;
import br.ufpr.tads.jfinisher.align.AlignerJA;
import br.ufpr.tads.jfinisher.align.AlignerJCS;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 *
 * @author vitor
 */
public class AlignFrame extends javax.swing.JFrame {

    private List<OpenSequence> openSequence = new ArrayList<OpenSequence>();
    private OpenSequenceAlignment openSequenceAlignment;
    private List<Integer> medians;
    private List<String> result = new ArrayList<String>();
    private Thread exec;
    private Thread aligner;
    private boolean interruptedThread;

    public AlignFrame(OpenSequence os) {
        this.openSequence.add(os);
        initComponents();
    }

    public AlignFrame(List<OpenSequence> os) {
        this.openSequence = os;
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        jLabel1 = new javax.swing.JLabel();
        repeatAlignment = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        extendGapPenaltyText = new javax.swing.JTextField();
        openGapPenaltyText = new javax.swing.JTextField();
        seedLengthText = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        alignProgressBar = new javax.swing.JProgressBar();
        cancelButton = new javax.swing.JButton();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("br/ufpr/tads/jfinisher/resource/messages"); // NOI18N
        setTitle(bundle.getString("AlignFrame.title")); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${defaultCloseOperation}"), this, org.jdesktop.beansbinding.BeanProperty.create("defaultCloseOperation"));
        bindingGroup.addBinding(binding);

        jLabel1.setText(bundle.getString("AlignFrame.repeatAlignment.text")); // NOI18N

        repeatAlignment.setValue(1);

        jLabel2.setText("Seed length");

        jLabel4.setText("Open Gap Penalty");

        jLabel5.setText("Extend Gap Penalty");

        extendGapPenaltyText.setText(String.valueOf(JFinisher.tmpExtendGapPenalty));

        openGapPenaltyText.setText(String.valueOf(JFinisher.tmpOpenGapPenalty));

        seedLengthText.setText(String.valueOf(JFinisher.tmpSeedLenght));

        okButton.setText(bundle.getString("AlignFrame.align.text")); // NOI18N
        okButton.setPreferredSize(new java.awt.Dimension(46, 27));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        closeButton.setText(bundle.getString("AlignFrame.close.text")); // NOI18N
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("Button.cancel")); // NOI18N
        cancelButton.setEnabled(false);
        cancelButton.setMaximumSize(new java.awt.Dimension(46, 27));
        cancelButton.setMinimumSize(new java.awt.Dimension(46, 27));
        cancelButton.setPreferredSize(new java.awt.Dimension(46, 27));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(alignProgressBar, javax.swing.GroupLayout.DEFAULT_SIZE, 327, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(141, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(closeButton, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(8, 8, 8))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 43, Short.MAX_VALUE)
                        .addComponent(repeatAlignment, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(layout.createSequentialGroup()
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(jLabel4)
                                    .addGap(22, 22, 22))
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(jLabel5)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(extendGapPenaltyText, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(openGapPenaltyText, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabel2)
                            .addGap(58, 58, 58)
                            .addComponent(seedLengthText, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(repeatAlignment, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(seedLengthText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(openGapPenaltyText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addGap(7, 7, 7)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(extendGapPenaltyText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(closeButton))
                .addGap(18, 18, 18)
                .addComponent(alignProgressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        this.dispose();
    }//GEN-LAST:event_closeButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        exec = new Thread() {

            @Override
            public void run() {
                interruptedThread = false;
                align();
            }
        };
        enableFields(false);
        exec.start();

    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        interruptedThread = true;
        exec.interrupt();
        aligner.interrupt();

        try {
            aligner.join();
        } catch (InterruptedException e) {
        }
        try {
            exec.join();
        } catch (InterruptedException e) {
        }

        enableFields(true);
        this.alignProgressBar.setValue(this.alignProgressBar.getMaximum());
        this.alignProgressBar.setString(JFinisher.textResource.getString(("AlignFrame.alignmentCanceled.text")));
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void align() {

        this.result.clear();
        
        //Pega valores da tela
        int repeat = Integer.parseInt(this.repeatAlignment.getValue().toString());
        int sl = Integer.parseInt(this.seedLengthText.getText());
        float ogp = Float.parseFloat(this.openGapPenaltyText.getText());
        float egp = Float.parseFloat(this.extendGapPenaltyText.getText());

        int maxProgress = repeat * openSequence.size();
        this.alignProgressBar.setMinimum(0);
        this.alignProgressBar.setMaximum(maxProgress);
        this.alignProgressBar.setValue(this.alignProgressBar.getMinimum());
        this.alignProgressBar.setStringPainted(true);
        this.alignProgressBar.setString(JFinisher.textResource.getString("AlignFrame.aligningContigs.text"));
        int progressCont = 0;

        //Salva em variavel temporria para usar enquanto o programa estiver sendo executado
        JFinisher.tmpSeedLenght = sl;
        JFinisher.tmpOpenGapPenalty = ogp;
        JFinisher.tmpExtendGapPenalty = egp;


        try {

            //Caso tenha cancelado, sai do mtodo
            if (interruptedThread) {
                throw new InterruptedException();
            }

            //Caso seja o primeiro alinhamento e repita apenas 1 vez
            if (repeat == 1 && openSequence.size() > 1 && JFinisher.isFirstAlignment()) {
                this.setMedians(null);
                
                aligner = new AlignerJCS(sl, openSequence, JFinisher.getReferenceOpenSequence().getSequence(), this);
                aligner.start();
                aligner.join();

                System.gc();
                try {
                    Thread.sleep(1);
                } catch (InterruptedException e) {
                }


                //Caso tenha cancelado, sai do mtodo
                if (interruptedThread) {
                    throw new InterruptedException();
                }


                //Caso retornou as medianas do contigsort
                if (medians != null) {
                    if (medians.size() != openSequence.size()) {
                        addResult(JFinisher.textResource.getString("Error.alignment"));
                    } else {

                        //loop nas medianas de retorno
                        for (int m = 0; m <= medians.size() - 1; m++) {
                            //Caso tenha cancelado, sai do mtodo
                            if (interruptedThread) {
                                throw new InterruptedException();
                            }

                            this.setOpenSequenceAlignment(null);

                            aligner = new AlignerJA(egp, egp, openSequence.get(m).getSequence(), JFinisher.getReferenceOpenSequence().getSequence(), medians.get(m), this, JFinisher.getOpenSequenceIndex(openSequence.get(m)));
                            aligner.start();
                            aligner.join();

                            System.gc();
                            try {
                                Thread.sleep(1);
                            } catch (InterruptedException e) {
                            }

                            //Caso tenha cancelado, sai do mtodo
                            if (interruptedThread) {
                                throw new InterruptedException();
                            }

                            if (this.openSequenceAlignment != null) {
                                posAlignment(this.openSequenceAlignment, openSequence.get(m), false);
                            }

                            alignProgressBar.setValue(m + 1);

                        }
                    }

                }
            } else {

                //For para quantidade de alinhamento por sequencia
                for (int i = 0; i < repeat; i++) {

                    //For nas sequencias escolhidas
                    for (OpenSequence os : openSequence) {

                        //Caso tenha cancelado, sai do mtodo
                        if (interruptedThread) {
                            throw new InterruptedException();
                        }

                        progressCont++;

                        this.setOpenSequenceAlignment(null);
                        this.setMedians(null);

                        Sequence refSeq = JFinisher.getReferenceOpenSequence().getSequenceWithoutAlignmentArea(os);

                        aligner = new AlignerJCS(sl, os, refSeq, this);
                        aligner.start();
                        aligner.join();

                        System.gc();
                        try {
                            Thread.sleep(1);
                        } catch (InterruptedException e) {
                        }


                        //Caso tenha cancelado, sai do mtodo
                        if (interruptedThread) {
                            throw new InterruptedException();
                        }

                        aligner = new AlignerJA(egp, egp, os.getSequence(), refSeq, medians.get(0), this, JFinisher.getOpenSequenceIndex(os));
                        aligner.start();
                        aligner.join();

                        System.gc();
                        try {
                            Thread.sleep(1);
                        } catch (InterruptedException e) {
                        }

                        //Caso tenha cancelado, sai do mtodo
                        if (interruptedThread) {
                            throw new InterruptedException();
                        }

                        if (this.openSequenceAlignment != null) {
                            boolean showOutput = false;
                            if (openSequence.size() == 1 && repeat == 1) {
                                showOutput = true;
                            }
                            posAlignment(this.openSequenceAlignment, os, showOutput);
                        }

                        alignProgressBar.setValue(progressCont);

                    }


                }

            }
        } catch (InterruptedException ex) {
            addResult(JFinisher.textResource.getString("Error.canceledByUser"));
        } catch (Exception ex) {
            addResult(JFinisher.textResource.getString("Error.unknown"));
        }


        enableFields(true);
        this.alignProgressBar.setString(JFinisher.textResource.getString(("AlignFrame.alignmentCompleted.text")));

        new AlignmentOutput(result);
    }

    private void posAlignment(OpenSequenceAlignment osa, OpenSequence os, boolean showOutput) {
        //Armazena alinhamento anteror e seleciona novo
        OpenSequenceAlignment oldOsa = os.getOpenSequenceAlignmentSelected();
        os.setOpenSequenceAlignmentSelected(osa);

        //Adiciona alinhamento ao objeto
        os.addAlignment(osa);

        //Adiciona alinhamento no mapa
        JFinisher.mainFrame.sspMap.addSequenceAlignment(os, osa);
        //Move sequencia na tela
        JFinisher.mainFrame.sspContigs.moveSequence(os, osa, oldOsa);
        //Marca sequencia no mapa
        JFinisher.mainFrame.sspMap.paintAlign(os, osa);


        //Mostra sada e centraliza na tela
        if (showOutput) {
            new AlignmentOutput(osa);
            if (osa == null) {
                JFinisher.mainFrame.sspContigs.setViewportPosition(0, os);
            } else {
                JFinisher.mainFrame.sspContigs.setViewportPosition(osa.getPosition(), os);

            }

        }

        addResult(JFinisher.getOpenSequenceIndex(os) + " - " + JFinisher.textResource.getString(("Message.aligned")));
    }

    protected JComponent makeTextPanel(String text) {
        JPanel panel = new JPanel(false);
        JLabel filler = new JLabel(text);
        filler.setHorizontalAlignment(JLabel.CENTER);
        panel.setLayout(new GridLayout(1, 1));
        panel.add(filler);
        return panel;
    }

    public void setOpenSequenceAlignment(OpenSequenceAlignment openSequenceAlignment) {
        this.openSequenceAlignment = openSequenceAlignment;
    }

    public void setMedians(List<Integer> medians) {
        this.medians = medians;
    }

    public void addResult(String result) {
        this.result.add(result);
    }

    private void enableFields(boolean option) {
        this.repeatAlignment.setEnabled(option);
        this.seedLengthText.setEnabled(option);
        this.openGapPenaltyText.setEnabled(option);
        this.extendGapPenaltyText.setEnabled(option);
        this.closeButton.setEnabled(option);
        this.okButton.setEnabled(option);
        this.cancelButton.setEnabled(!option);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JProgressBar alignProgressBar;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton closeButton;
    private javax.swing.JTextField extendGapPenaltyText;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JButton okButton;
    private javax.swing.JTextField openGapPenaltyText;
    private javax.swing.JSpinner repeatAlignment;
    private javax.swing.JTextField seedLengthText;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
}