/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GoToFrame.java
 *
 * Created on 16/01/2012, 20:36:16
 */
package br.ufpr.tads.jfinisher.frame;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.enumerator.PanelType;

/**
 *
 * @author vitor
 */
public class GoToFrame extends javax.swing.JFrame {

    private OpenSequence openSequence;
    private PanelType panelType;

    /** Creates new form GoToFrame */
    public GoToFrame(OpenSequence os, PanelType pt) {
        this.openSequence = os;
        this.panelType = pt;
        initComponents();
        this.gotoBaseText.requestFocus();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        findBasePatternButton = new javax.swing.JRadioButton();
        gotoBaseButton = new javax.swing.JRadioButton();
        findBasePatternText = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        gotoBaseText = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("br/ufpr/tads/jfinisher/resource/messages"); // NOI18N
        setTitle(bundle.getString("GoToFrame.title")); // NOI18N

        buttonGroup1.add(findBasePatternButton);
        findBasePatternButton.setText(bundle.getString("GoToFrame.findBasePattern.text")); // NOI18N
        findBasePatternButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findBasePatternButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(gotoBaseButton);
        gotoBaseButton.setSelected(true);
        gotoBaseButton.setText(bundle.getString("GoToFrame.gotoBase.text")); // NOI18N

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("Button.cancel")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(findBasePatternButton)
                    .addComponent(gotoBaseButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(findBasePatternText)
                    .addComponent(gotoBaseText, javax.swing.GroupLayout.PREFERRED_SIZE, 193, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(157, Short.MAX_VALUE)
                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(gotoBaseButton)
                    .addComponent(gotoBaseText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(findBasePatternButton)
                    .addComponent(findBasePatternText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        this.dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        int posI = -1, posF=-1;
        if (this.gotoBaseButton.isSelected() && !this.gotoBaseText.getText().isEmpty()) {
            posI = Integer.valueOf(this.gotoBaseText.getText()) - 1;
            posF = posI;
        } else if (this.findBasePatternButton.isSelected() && !this.findBasePatternText.getText().isEmpty()) {
            posI = openSequence.searchSequence(this.findBasePatternText.getText());
            posF = posI + this.findBasePatternText.getText().length() -1;
        }
        if (posI >= -1 && posI <= openSequence.getSequence().getLength() - 1) {
            openSequence.getSelectedSeq().setBounds(posI, posF);
            openSequence.getSequencePanel().highlight();
            if (panelType == PanelType.CONTIGS_PANEL) {
                if (openSequence.getAlignment().size() > 0) {
                    posI += openSequence.getOpenSequenceAlignmentSelected().getPosition();
                }
                JFinisher.mainFrame.sspContigs.setViewportPosition(posI, openSequence);
                JFinisher.mainFrame.sspContigs.refreshViewportView();
            } else {
                JFinisher.mainFrame.sspReference.setViewportPosition(posI, openSequence);
                JFinisher.mainFrame.sspReference.refreshViewportView();
            }
        }
    }//GEN-LAST:event_okButtonActionPerformed

    private void findBasePatternButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findBasePatternButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_findBasePatternButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton cancelButton;
    private javax.swing.JRadioButton findBasePatternButton;
    private javax.swing.JTextField findBasePatternText;
    private javax.swing.JRadioButton gotoBaseButton;
    private javax.swing.JTextField gotoBaseText;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
}
