package br.ufpr.tads.jfinisher.frame;

import br.ufpr.bioinfo.sequence.fasta.Fasta;
import br.ufpr.bioinfo.sequence.fasta.FastaUtil;
import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.Sequence;
import br.ufpr.tads.jfinisher.action.OpenAction;
import br.ufpr.tads.jfinisher.util.WindowUtil;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

public class JoinSequencesFrame extends javax.swing.JFrame {

    public JoinSequencesFrame() {
        initComponents();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        joinAllRadioButton = new javax.swing.JRadioButton();
        joinSpecificRadioButton = new javax.swing.JRadioButton();
        createNewRadioButton = new javax.swing.JRadioButton();
        replaceFirstRadioButton = new javax.swing.JRadioButton();
        specificSequencesTextField = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("br/ufpr/tads/jfinisher/resource/messages"); // NOI18N
        setTitle(bundle.getString("JoinSequencesFrame.title")); // NOI18N

        buttonGroup1.add(joinAllRadioButton);
        joinAllRadioButton.setSelected(true);
        joinAllRadioButton.setText(bundle.getString("JoinSequencesFrame.joinAllRadioButton.text")); // NOI18N
        joinAllRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                joinAllRadioButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(joinSpecificRadioButton);
        joinSpecificRadioButton.setText(bundle.getString("JoinSequencesFrame.joinSpecificRadioButton.text")); // NOI18N
        joinSpecificRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                joinSpecificRadioButtonActionPerformed(evt);
            }
        });

        buttonGroup2.add(createNewRadioButton);
        createNewRadioButton.setSelected(true);
        createNewRadioButton.setText(bundle.getString("JoinSequencesFrame.createNewRadioButton.text")); // NOI18N

        buttonGroup2.add(replaceFirstRadioButton);
        replaceFirstRadioButton.setText(bundle.getString("JoinSequencesFrame.replaceFirstRadioButton.text")); // NOI18N

        specificSequencesTextField.setEnabled(false);

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("Button.cancel")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGap(21, 21, 21)
                            .addComponent(specificSequencesTextField))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addComponent(createNewRadioButton)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(replaceFirstRadioButton))
                        .addComponent(joinSpecificRadioButton, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(joinAllRadioButton, javax.swing.GroupLayout.Alignment.LEADING)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(joinAllRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(joinSpecificRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(specificSequencesTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(15, 15, 15)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(createNewRadioButton)
                    .addComponent(replaceFirstRadioButton))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void joinSpecificRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_joinSpecificRadioButtonActionPerformed
        this.specificSequencesTextField.setEnabled(true);
    }//GEN-LAST:event_joinSpecificRadioButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        this.dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed

        //Verificao de novo arquivo
        boolean fileOk = false;

        //Novo arquivo
        File newFile = null;

        //Caso selecione opo de criar novo arquivo, mostra seletor de arquivo
        if (this.createNewRadioButton.isSelected()) {
            FileNameExtensionFilter fe = new FileNameExtensionFilter(JFinisher.textResource.getString("JoinSequencesFrame.files"), "fasta");
            JFileChooser openDialog = WindowUtil.getOpenChooser();
            openDialog.setDialogTitle(JFinisher.textResource.getString("JoinSequencesFrame.title"));
            openDialog.setDialogType(JFileChooser.SAVE_DIALOG);
            openDialog.setFileFilter(fe);
            openDialog.setCurrentDirectory(new File("."));
            openDialog.setSelectedFile(new File("*.fasta"));
            while (!fileOk) {
                if (openDialog.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
                    if (openDialog.getSelectedFile().exists()) {
                        int overwrite = JOptionPane.showConfirmDialog(this, JFinisher.textResource.getString("SaveProjectAction.fileExists"), JFinisher.textResource.getString("SaveProjectAction.title") + " [" + openDialog.getSelectedFile().getName() + "]", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
                        if (overwrite == JOptionPane.YES_OPTION) {
                            fileOk = true;
                            newFile = openDialog.getSelectedFile();
                            break;
                        } else if (overwrite == JOptionPane.CANCEL_OPTION) {
                            break;
                        }
                    } else {
                        fileOk = true;
                        newFile = openDialog.getSelectedFile();
                    }
                }else{
                     break;
                }
            }
        } else if (this.replaceFirstRadioButton.isSelected()) {
            fileOk = true;
        }


        //Caso tenha selecionado novo arquivo corretamente
        if (fileOk) {

            //Lista das sequencias escolhidas para unificar
            List<OpenSequence> openSequences = new ArrayList<OpenSequence>();

            //Nova sequencia gerada
            OpenSequence newOpenSequence = null;

            //Caso selecione todas, pega todos os contigs
            if (this.joinAllRadioButton.isSelected()) {
                openSequences = JFinisher.getContigsOpenSequence();
            } else if (this.joinSpecificRadioButton.isSelected()) {
                //loop atraves do numeros selecionando as sequencias escolhidas
                openSequences = new ArrayList<OpenSequence>();
                String s[] = this.specificSequencesTextField.getText().split("\\,");
                for (int i = 0; i <= s.length - 1; i++) {
                    int sequenceN = Integer.valueOf(s[i]);
                    if (sequenceN >= 1 && sequenceN <= JFinisher.getOpenSequencesSize()) {
                        openSequences.add(JFinisher.getOpenSequence(sequenceN));
                    }
                }
            }

            //Cria nova sequencia (realizando um consenso entre as escolhidas)
            Sequence newSequence = JFinisher.createConsensus(openSequences);

            
            //Caso substitua a primeira
            if (this.replaceFirstRadioButton.isSelected()) {

                newOpenSequence = openSequences.get(0);
                newOpenSequence.removeAllOpenSequenceAlignment();
                newOpenSequence.setSequence(newSequence);

                JFinisher.mainFrame.sspContigs.refreshSequence(newOpenSequence);
                JFinisher.mainFrame.sspMap.refreshSequence(newOpenSequence);


                for (int i = openSequences.size() - 1; i > 0; i--) {
                    JFinisher.mainFrame.sspContigs.removeSequence(JFinisher.getOpenSequence(i), false);
                }
            } else if (this.createNewRadioButton.isSelected()) {
                FastaUtil fstUtil = new FastaUtil();
                Fasta fst = new Fasta();
                fst.setHeader("jfinisher contig");
                fst.setSequence(newSequence.getSeq());
                fstUtil.writeFasta(fst, newFile);

                OpenAction openAction = new OpenAction();
                
                try {
                    ArrayList<OpenSequence> os = openAction.openFile(newFile);
                    openAction.addSequence(os);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(JFinisher.mainFrame, JFinisher.textResource.getString("Error.unknown"), JFinisher.textResource.getString("Error.title"), JOptionPane.ERROR_MESSAGE);
                }

            }
            JFinisher.mainFrame.refreshComponents();
        }
    }//GEN-LAST:event_okButtonActionPerformed
    private void joinAllRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_joinAllRadioButtonActionPerformed
        this.specificSequencesTextField.setText("");
        this.specificSequencesTextField.setEnabled(false);
    }//GEN-LAST:event_joinAllRadioButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JButton cancelButton;
    private javax.swing.JRadioButton createNewRadioButton;
    private javax.swing.JRadioButton joinAllRadioButton;
    private javax.swing.JRadioButton joinSpecificRadioButton;
    private javax.swing.JButton okButton;
    private javax.swing.JRadioButton replaceFirstRadioButton;
    private javax.swing.JTextField specificSequencesTextField;
    // End of variables declaration//GEN-END:variables
}
