package br.ufpr.tads.jfinisher.listener;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.OpenSequenceAlignment;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class MapMouseListener extends MouseAdapter {

    private OpenSequence openSequence;
    private OpenSequenceAlignment openSequenceAlignment;

    public MapMouseListener(OpenSequence os) {
        this.openSequence = os;
    }

    public MapMouseListener(OpenSequence os, OpenSequenceAlignment osa) {
        this.openSequence = os;
        this.openSequenceAlignment = osa;
    }

    @Override
    public void mouseClicked(MouseEvent e) {
        //Double click - Seleciona sequencia inteira
        if (e.getClickCount() > 1) {
            openSequence.getSelectedSeq().setBounds(0, openSequence.getSequence().getLength());
            openSequence.getSequencePanel().highlight();
        } else {
            openSequence.getSequencePanel().clearHighlight();
        }

        JFinisher.mainFrame.sspMap.showSequence(openSequence, openSequenceAlignment);
        
    }
}
