/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.ufpr.tads.jfinisher.listener;
import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.frame.MainFrame;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.enumerator.PanelType;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.SwingUtilities;

/**
 *
 * @author vitor
 */
public class SequenceMouseListener extends MouseAdapter {

    private OpenSequence openSequence;
    private PanelType panelType;
    
    public SequenceMouseListener(OpenSequence os, PanelType pt){
        this.openSequence = os;
        this.panelType = pt;
    }
    
    
    @Override
    public void mousePressed(MouseEvent e) {
        if (SwingUtilities.isLeftMouseButton(e)) {
            //Retorna qual caractere foi clicado
            int c = (int) Math.ceil(e.getX() / JFinisher.fontWidht);
            if (c < openSequence.getSequence().getLength()) {
                openSequence.getSelectedSeq().setBounds(c, c);
                openSequence.getSequencePanel().highlight();
            } else {
                openSequence.getSequencePanel().clearHighlight();
            }            
        }
    }

    @Override
    public void mouseDragged(MouseEvent e) {

        if (SwingUtilities.isLeftMouseButton(e)) {
            //Retorna qual caractere foi clicado
            int c = (int) Math.ceil(e.getX() / JFinisher.fontWidht);

            //Caso caractere esteja dentro do range
            if (c < openSequence.getSequence().getLength()) {
                //Faz verificao de scroll frente/tras
                int end = openSequence.getSelectedSeq().getEnd(), start = openSequence.getSelectedSeq().getStart();
                if (end == start) {
                    if (c > start) {
                        openSequence.getSelectedSeq().setEnd(c);
                    } else {
                        openSequence.getSelectedSeq().setStart(c);
                    }
                } else if (c > end) {
                    openSequence.getSelectedSeq().setEnd(c);
                } else if (c < end && c < start) {
                    openSequence.getSelectedSeq().setStart(c);
                } else if (c < end && c > start) {
                    int d1 = c - start, d2 = c - end;
                    if (Math.abs(d1) < Math.abs(d2)) {
                        openSequence.getSelectedSeq().setStart(c);
                    } else {
                        openSequence.getSelectedSeq().setEnd(c);
                    }
                }
                openSequence.getSequencePanel().highlight();
                
                if(panelType==PanelType.REFERENCE_PANEL){
                    JFinisher.mainFrame.sspReference.setViewportPositionScroll(e.getX(), openSequence.getSequencePanel().getX());
                }else if(panelType==PanelType.CONTIGS_PANEL){
                    JFinisher.mainFrame.sspContigs.setViewportPositionScroll(e.getX(), openSequence.getSequencePanel().getX());
                }
                //System.out.println(JFinisher.openSequences.get(JFinisher.openSequences.indexOf(this.getOpenSequence())).getSelectedSeq().getSeq().getSeqStr());
            }
        }
        
    }
    
}
