package br.ufpr.tads.jfinisher.sequencepanel;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.Sequence;
import java.util.List;

public class SequencePanelConsensus extends SequencePanel {

    private Sequence consensusSequence;

    protected void createSequence(int sequenceLength) {
        //Inicia a sequencia com tamanho necessrio
        consensusSequence = new Sequence(sequenceLength);
        //Preenche sequencia com caracter "-"
        consensusSequence.setSeqFill(JFinisher.fillChar);
        //Monta sequencia
        packPanel(consensusSequence);
    }
    
    protected void refreshSequence(List<OpenSequence> openSequences) {
        Sequence cs = JFinisher.createConsensus(openSequences);
        consensusSequence.setSeq(cs.getSeq(), 0, cs.getLength()-1);
        packPanel(consensusSequence);
    }
    protected void refreshSequence(int ini, int end) {
        int l =consensusSequence.getLength()-1;
        ini = ini<0 ? 0 : ini;
        end = end>l ? l : end; 
        Sequence cs = JFinisher.createConsensus(JFinisher.getContigsOpenSequence(), ini, end);
        consensusSequence.setSeq(cs.getSeq(), ini, end);
        packPanel(consensusSequence);
    }

    protected Sequence getConsensusSequence() {
        return consensusSequence;
    }
}
