package br.ufpr.tads.jfinisher.sequencepanel;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.enumerator.PanelType;
import br.ufpr.tads.jfinisher.listener.SequenceMenuListener;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Point;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.SwingConstants;
import javax.swing.border.Border;

public class SequenceScrollPane extends JScrollPane {

    //Painel Agregador sequencias, contador, consenso
    protected JPanel jp = new JPanel(new GridBagLayout());
    //Painel para cabealho de cada linha
    protected JPanel hjp = new JPanel(new GridBagLayout());
    //Paineis alinhadores (contem paines de conteudo)
    protected JPanel jp_a = new JPanel(new BorderLayout());
    protected JPanel hjp_a = new JPanel(new BorderLayout());
    //Painel para sequencias
    protected SequencePanelSeq jps;
    //Configuracoes do GridBagLayout
    protected GridBagConstraints cons = new GridBagConstraints();
    private Border headerBorder = BorderFactory.createMatteBorder(0, 0, 0, 1, Color.BLACK);

    public SequenceScrollPane() {
        super();
        hjp_a.setBorder(headerBorder);

        //Adiciona paines de conteudo nos alinhadores
        jp_a.add(jp, BorderLayout.NORTH);
        hjp_a.add(hjp, BorderLayout.NORTH);

        cons.fill = GridBagConstraints.HORIZONTAL;
    }

    public void setViewportPositionScroll(int x, int contigPos) {
        x += JFinisher.descriptionSize * JFinisher.fontWidht + contigPos;
        if (x >= 0) {

            JViewport vp = this.getViewport();
            //Limite da tela (retira espao inserido pela descricao)
            double xLimit = vp.getBounds().getWidth();

            int xPos = vp.getViewPosition().x;

            if (x > (xLimit + xPos)) {
                setViewportPositionXY(xPos + JFinisher.scrollUnitIncrement, vp.getViewPosition().y);
            } else {
                if (x < xPos) {
                    setViewportPositionXY(xPos - JFinisher.scrollUnitIncrement, vp.getViewPosition().y);
                }
            }

            //System.out.println("X:" + x + "   xPos:" + xPos + "   xLimit:" + xLimit + "   xPos:" + (xLimit + xPos));
        }
    }

    
    public void setViewportPosition(int charPosition, OpenSequence os) {     
        int x = charPosition * JFinisher.fontWidht;
        int y=0;
        if(!os.isReferenceSequence()){
            y = (JFinisher.getOpenSequenceIndex(os) - 1) * JFinisher.fontHeight;
        }
        x = (int) ((x > 0) ? x : 0);
        y = (int) ((y > 0) ? y : 0);
        setViewportPositionXY(x, y);
    }

    private void setViewportPositionXY(int x, int y) {
        JViewport vp = this.getViewport();
        //No deixa passar dos valores limite
        int yL = getVerticalScrollBar().getMaximum() - getVerticalScrollBar().getVisibleAmount();
        y = (int) ((y > yL) ? yL : y);
        int xL = getHorizontalScrollBar().getMaximum() - getHorizontalScrollBar().getVisibleAmount();
        x = (int) ((x > xL) ? xL : x);

        //Posiciona tela
        vp.setViewPosition(new Point(x, y));
    }

    protected JLabel sequenceDescription(OpenSequence os) {
        JLabel labelDesc = new JLabel(os.getDescription());
        labelDesc.setFont(JFinisher.font);
        labelDesc.setBorder(headerBorder);
        labelDesc.setPreferredSize(new Dimension(JFinisher.descriptionSize * JFinisher.fontWidht, JFinisher.fontHeight));
        labelDesc.addMouseListener(new SequenceMenuListener(os, PanelType.CONTIGS_PANEL));
        labelDesc.setToolTipText(JFinisher.getOpenSequenceIndex(os) + " " + os.getDescription());
        return labelDesc;
    }

    protected JLabel sequenceDescription(String description) {
        JLabel labelDesc = new JLabel(description);
        labelDesc.setFont(JFinisher.font);
        labelDesc.setBorder(headerBorder);
        labelDesc.setPreferredSize(new Dimension(JFinisher.descriptionSize * JFinisher.fontWidht, JFinisher.fontHeight));
        return labelDesc;
    }

    protected JLabel sequenceHeader(OpenSequence os) {
        JLabel labelHeader = new JLabel(String.valueOf(JFinisher.getOpenSequenceIndex(os)), SwingConstants.CENTER);
        labelHeader.setFont(JFinisher.font);
        labelHeader.addMouseListener(new SequenceMenuListener(os, PanelType.CONTIGS_PANEL));
        labelHeader.setToolTipText(JFinisher.getOpenSequenceIndex(os) + " " + os.getDescription());
        return labelHeader;
    }

    protected JLabel sequenceHeader(String header) {
        JLabel labelHeader = new JLabel(header, SwingConstants.CENTER);
        labelHeader.setFont(JFinisher.font);
        return labelHeader;
    }

    public void refreshViewportView() {  
        this.setRowHeaderView(hjp_a);
        this.setViewportView(jp_a);
    }

    public void refreshRowHeaderWidth() {
        int size = JFinisher.getOpenSequencesSize();
        int width = JFinisher.fontWidht * Integer.toString(size - 1).length();
        int heigth = JFinisher.fontHeight * (size - 1);
        hjp_a.setPreferredSize(new Dimension(width + 4, heigth));
    }

    public void clear() {
        this.hjp.removeAll();
        this.jp.removeAll();
    }
    
    

}
