package br.ufpr.tads.jfinisher.sequencepanel;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.frame.MainFrame;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.OpenSequenceAlignment;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import javax.swing.Box;
import javax.swing.JPanel;

public class SequenceScrollPaneContig extends SequenceScrollPane {

    private Component aligner;
    private Component horizontalSpace;

    public void addSequence(OpenSequence os) {

        //Sequencia (contig)
        cons.gridx = 0;
        cons.weightx = 0;
        hjp.add(sequenceHeader(os), cons);
        jp.add(sequenceDescription(os), cons);
        
        //Alinhador e sequencia
        cons.gridx = 1;
        cons.weightx = 1;
        JPanel jpa = new JPanel(new FlowLayout(FlowLayout.LEFT, 0, 0));
        aligner = Box.createHorizontalStrut(0);
        jpa.add(aligner);
        jps = new SequencePanelSeq(os);

        jpa.add(jps);
        jp.add(jpa, cons);

        os.setSequencePanel(jps);
        os.setAligner(aligner);
    }

    public void addHorizontalSpace() {
        if (JFinisher.getReferenceOpenSequence() != null) {
            //Adiciona espao no final do painel alinhador para scrolls ficarem com mesmo tamanho
            horizontalSpace = Box.createHorizontalStrut((JFinisher.getReferenceOpenSequence().getSequence().getLength() + JFinisher.descriptionSize + JFinisher.basesCont) * JFinisher.fontWidht);
            jp_a.add(horizontalSpace, BorderLayout.SOUTH);
        }

    }

    public void removeHorizontalSpace() {
        if (horizontalSpace != null) {
            jp_a.remove(horizontalSpace);
        }

    }

    public void removeSequence(OpenSequence os, boolean removeFromFile) {

        if (removeFromFile) {
            os.removeFromFile();
        }

        //Remove sequencia e descricao
        int r = JFinisher.getOpenSequenceIndex(os) * 2;
        jp.remove(r - 1);
        jp.remove(r - 2);


        //Retira 1 contador
        hjp.remove(hjp.getComponentCount() - 1);

        //Remove sequencia do mapa
        JFinisher.mainFrame.sspMap.removeSequence(os);

        //Salva valores para atualizar consenso
        int pos = 0;
        int len = os.getSequence().getLength();

        //Remove sequencia do objeto principal
        JFinisher.removeOpenSequence(os);

        //Atualiza consenso
        JFinisher.mainFrame.sspReference.refreshConsensusSequence(pos, pos + len - 1);
        JFinisher.mainFrame.sspReference.refreshViewportView();

        //Atualiza tela
        this.refreshViewportView();

    }

    public void moveSequence(OpenSequence os, OpenSequenceAlignment newOsa, OpenSequenceAlignment oldOsa) {
        //Caso seja nulo, posio padro (zero) do contig
        if (newOsa == null) {
            os.setAlignerPosition(0);
            //Atualiza consenso da nova posicao
            JFinisher.mainFrame.sspReference.refreshConsensusSequence(0, os.getSequence().getLength() - 1);
        } else {
            os.setAlignerPosition(newOsa.getStartPosRef() - newOsa.getStartPosCont());
            //Atualiza consenso da nova posicao
            JFinisher.mainFrame.sspReference.refreshConsensusSequence(newOsa.getPosition(), newOsa.getPosition() + os.getSequence().getLength() - 1);
        }

        //Atualiza consenso de onde saiu
        if (oldOsa != null) {
            JFinisher.mainFrame.sspReference.refreshConsensusSequence(oldOsa.getPosition(), oldOsa.getPosition() + os.getSequence().getLength() - 1);
        } else {
            JFinisher.mainFrame.sspReference.refreshConsensusSequence(0, os.getSequence().getLength() - 1);
        }
        this.refreshViewportView();
        JFinisher.mainFrame.sspReference.refreshViewportView();

    }
    
    public void refreshSequence(OpenSequence os){
        os.getSequencePanel().refreshSequence();
    }

}