package br.ufpr.tads.jfinisher.sequencepanel;

import br.ufpr.tads.jfinisher.JFinisher;
import br.ufpr.tads.jfinisher.OpenSequence;
import br.ufpr.tads.jfinisher.Sequence;
import java.util.List;

public class SequenceScrollPaneReference extends SequenceScrollPane {

    //Painel do contador
    private SequencePanelCounter jpc;
    //Painel da ref. consenso
    private SequencePanelConsensus jpcs = new SequencePanelConsensus();

    public SequenceScrollPaneReference() {
        this.setSize(200, 200);
    }

    public void addSequence(OpenSequence os) {

        //Contador
        cons.gridx = 0;
        cons.gridy = 0;
        cons.weightx = 0;
        hjp.add(sequenceHeader("#"));
        jp.add(sequenceDescription(""), cons);
        cons.gridx = 1;
        cons.gridy = 0;
        cons.weightx = 1;
        jpc = new SequencePanelCounter(os.getSequence().getLength());
        jp.add(jpc, cons);


        //Sequencia Referencia
        cons.gridx = 0;
        cons.gridy = 1;
        cons.weightx = 0;
        hjp.add(sequenceHeader("R"), cons);
        jp.add(sequenceDescription(""), cons);
        cons.gridx = 1;
        cons.gridy = 1;
        cons.weightx = 1;
        jps = new SequencePanelSeq(os);
        jp.add(jps, cons);
        os.setSequencePanel(jps);

        jps.revalidate();
        jps.repaint();
    }

    public void refreshConsensusSequence(int ini, int end) {
        if (end - ini > 0) {
            cons.gridx = 1;
            cons.gridy = 2;
            jpcs.refreshSequence(ini, end);
            jp.add(jpcs, cons);
        }
    }

    public void refreshConsensusSequence(List<OpenSequence> openSequences) {

        cons.gridx = 1;
        cons.gridy = 2;
        jpcs.refreshSequence(openSequences);
        jp.add(jpcs, cons);

    }

    public void createConsensusSequence() {

        cons.gridx = 0;
        cons.gridy = 2;
        cons.weightx = 0;
        hjp.add(sequenceHeader("C"), cons);
        jp.add(sequenceDescription(""), cons);

        cons.gridx = 1;
        cons.gridy = 2;
        cons.weightx = 1;
        jpcs.createSequence(JFinisher.getReferenceOpenSequence().getSequence().getLength());
        jp.add(jpcs, cons);
    }

    public Sequence getConsensusSequence() {
        return jpcs.getConsensusSequence();
    }
}
